from sqlalchemy import Column, Integer, String, Float, Boolean, DateTime, Sequence, create_engine, MetaData
from sqlalchemy.orm import sessionmaker
from sqlalchemy.ext.declarative import declarative_base
import time

Engine = create_engine('postgres://minimal2:dupa.8@localhost/piwo')
Base = declarative_base()
Session = sessionmaker(bind=Engine)

class Drink(Base):
    __tablename__ = 'drinks'
    ID = Column(Integer, Sequence('drinks_id_seq'), primary_key=True)
    sink = Column(Integer)
    name = Column(String(30))
    cred = Column(Float)
    desc = Column(String(300))
    limit = Column(Boolean)

    def __init__(self, sink, name, cred, desc, limit=True):
        self.sink = sink
        self.name = name
        self.cred = cred
        self.desc = desc
        self.limit = limit

    def __repr__(self):
        return "Kran: %d, %s: %s, %f zł/kufel, %d" % (self.sink+1, self.name, self.desc, self.cred, self.limit)

class User(Base):
    __tablename__ = 'users'
    ID = Column(String(256), primary_key=True)
    nick = Column(String(32))
    pwd = Column(String(512))
    cred = Column(Float())

    def __init__(self, id, nick, pwd, cred=0):
        self.ID = id
        self.nick = nick
        self.cred = cred
        self.pwd = pwd

    def __repr__(self):
        return "Użytkownik: %s; %f zł" % (self.nick, self.cred)

class Transaction(Base):
    __tablename__ = 'transactions'
    ID = Column(Integer, Sequence('transactions_id_seq'), primary_key=True)
    timestamp = Column(DateTime)
    drink = Column(Integer) # foreign key z drinks
    who = Column(String(256)) # foreign key z users
    weight = Column(Float())
    cost = Column(Float())

    def __init__(self, drink, who, weight, cost):
        self.timestamp = time.time()
        self.drink = drink
        self.who = who
        self.weight = weight
        self.cost = cost

    def __repr__(self):
        return("Transakcja: %d; %s; %d; %d; %f; %f" \
               % (self.ID, self.timestamp, self.drink, self.who, self.weight, self.cost))

def getDrinks():
    session = Session()
    sink = {}
    try:
        sink[0] = session.query(Drink).order_by(Drink.ID).filter_by(sink=0)[0]
    except:
        pass
    try:
        sink[1] = session.query(Drink).order_by(Drink.ID).filter_by(sink=1)[0]
    except:
        pass
    try:
        sink[2] = session.query(Drink).order_by(Drink.ID).filter_by(sink=2)[0]
    except:
        pass
    return sink;

def getUser(id):
    session = Session()
    return session.query(User).filter_by(ID=id)

def createDb():
    Base.metadata.create_all(Engine)